<?php
#Version 1.1 vom 12.04.2017

# Database variables
$username = "vz";
$password = 'demo';
$database = "volkszaehler";
$server = "localhost";

#Programm variables
$monate = array("Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember");
$image_path = "img";
$filename = 'eye.png';

$channel_name = array();
$channel_resolution = array();
$channel_color = array();
$channel_type = array();
$channel_units = array();
$channel_id = array();
$channel_nod = array();
$channel_max = array();
$channel_min = array();
$channel_selected = array();
$channel_average = array();
$channel_total = array();
$channelArray=array();


#Check if Form is transmitted
if (isset($_POST['month']) && isset($_POST['year'])) {
   foreach($_POST as $content) {
      if (strpos($content, "channel_") !== false) {
         $teile = explode("_", $content);
		 $channelArray[] = $teile[1];
      }
   }
}

#Check which Image Directory is correct
if (file_exists($image_path."/".$filename)) { $image_path = $image_path; } 
else if (file_exists("images/".$filename)) { $image_path = "images"; }
else { echo "Die Datei $filename konnte nicht gefunden werden";
}

#Print Header of Page
echo "<center>";
if (isset($_POST['month']) && isset($_POST['year'])) {
  $day = "01";
  $month = $_POST['month'];
  $month_selected = $_POST['month'];
  $year = $_POST['year'];
  if($_POST['month'] == "complete") { 
    $month = "01"; 
    echo "<h2>Statistikwerte vom Jahr $year </h2>\n";
  } else {
    echo "<h2>Statistikwerte vom ".$monate[$month-1]." $year </h2>\n";
  }
} else {
  $day = "01";
  $month = date("m");
  $month_selected = date("n");
  $year = date("Y");
  echo "<h2>Statistikwerte</h2>\n";
}
echo "</center>";


#Load additional VZ data
echo "<!-- jQuery -->\n";
echo "<script type=\"text/javascript\" src=\"vendor/jquery/jquery-2.1.3.min.js\"></script>\n";
echo "<script type=\"text/javascript\" src=\"vendor/jquery-ui/jquery-ui.min.js\"></script>\n";
echo "<script type=\"text/javascript\" src=\"javascripts/jquery/jquery-ext.min.js\"></script>\n";
echo "<script type=\"text/javascript\" src=\"vendor/autobahn.min.js\"></script>\n";
echo "<script type=\"text/javascript\" src=\"vendor/flot/flot.min.js\"></script>\n";
echo "<script type=\"text/javascript\" src=\"vendor/flot/jquery.flot.axislabels.js\"></script>\n";
echo "<script type=\"text/javascript\" src=\"vendor/flot/jquery.flot.symbol.js\"></script>\n";
echo "<script type=\"text/javascript\" src=\"vendor/flot/jquery.flot.time.js\"></script>\n";
echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"vendor/jquery-ui/jquery-ui.min.css\" />";
echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"stylesheets/sprites.css\" />";

#Connect to DB
$db = mysql_connect($server, $username, $password);
if (!$db) { die('Verbindung schlug fehl: ' . mysql_error()); }
$db_vz = mysql_select_db($database, $db);

#Get timeframe of VZ collected data
$str_sql = "SELECT MIN(timestamp), MAX(timestamp) FROM data;";
$sql_res = mysql_query($str_sql);
$row = mysql_fetch_assoc($sql_res);
$timestamp_min = round($row["MIN(timestamp)"]/1000, 0);
$year_min = date("Y", round($row["MIN(timestamp)"]/1000, 0));
$timestamp_max = round($row["MAX(timestamp)"]/1000, 0);
$year_max = date("Y", round($row["MAX(timestamp)"]/1000, 0));

#Prepare Form for time selection
$output_form = "";
$output_form .= "<form id='user_form' action='".htmlspecialchars($_SERVER["PHP_SELF"])."' method='post'>\n";
$output_form .= "<fieldset>\n";
$output_form .= "<select name='month'>\n";
$output_form .= "<option value='complete'>Komplett</option>";
for($i=1; $i<=12; $i++) {
  if($i == $month_selected) { $output_form .= "<option selected value='$i'>".$monate[$i-1]."</option>\n"; } 
  else { $output_form .= "<option value='$i'>".$monate[$i-1]."</option>\n"; }
}
$output_form .= "</select>\n";
$output_form .= "<select name='year'>\n";
for($i=$year_min; $i<=$year_max; $i++) {
  if($i == $year) { $output_form .= "<option selected value='".$i."'>".$i."</option>\n"; } 
  else { $output_form .= "<option value='".$i."'>".$i."</option>\n"; }
}
$output_form .= "</select>\n";
$output_form .= "<input type='submit' name='submit' value='submit'>\n<br>\n";

#Get Data of Channels in VZ
$str_sql = "SELECT id, type FROM entities where type not in ('group', 'voltage', 'humidity');";
$sql_res = mysql_query($str_sql);
while($row = mysql_fetch_object($sql_res)) {
  $id = $row->id;
  $channel_id[] = $id;
  $channel_type[$id] = $row->type;
  $channel_nod[$id]=0;
  $channel_max[$id]=0;
  $channel_min[$id]=999999999;
  $channel_average[$id]=0;
  $channel_total[$id]=0;
  if (in_array($id, $channelArray)){ $channel_selected[$id]=1; } 
  else { $channel_selected[$id]=0; }
  $channel_data[$id]="";
  if($channel_type[$id] == "power") { $channel_units[$id] = " KWh"; }
  else if($channel_type[$id] == "powersensor") { $channel_units[$id] = " KWh"; }
  else if($channel_type[$id] == "electric meter") { $channel_units[$id] = " KWh"; }
  else if($channel_type[$id] == "gas") { $channel_units[$id] = " m³"; }
  else if($channel_type[$id] == "water") { $channel_units[$id] = " L"; }
  else if($channel_type[$id] == "temperature") { $channel_units[$id] = " °C"; }
  else { $channel_units[$id] = ""; }
}
$str_sql = "SELECT * FROM properties where pkey = 'title' or pkey = 'resolution' or pkey = 'color'";
$sql_res = mysql_query($str_sql);
while($row = mysql_fetch_object($sql_res)) {
   $id = $row->entity_id;
   $pkey = $row->pkey;
   $value = $row->value;
   if($pkey == "title") { $channel_name[$id] = $value; }
   else if ($pkey == "resolution") { $channel_resolution[$id] = $value; }
   else if ($pkey == "color") { $channel_color[$id] = $value; }
}



#Prepare Table Output
$output_table = "<table border=\"1\"><tr><th>Datum</th>";
for($i=0; $i < count($channelArray); $i++) {
   if($channel_selected[$channelArray[$i]] == 1) {
      if ($channel_type[$channelArray[$i]] != "temperature") {
         $output_table .= "<th>&nbsp;</th><th>".$channel_name[$channelArray[$i]]."</th>";
      } else {
		 $output_table .= "<th>&nbsp;</th><th>".$channel_name[$channelArray[$i]]." Min.</th><th>".$channel_name[$channelArray[$i]]." &#216;</th><th>".$channel_name[$channelArray[$i]]." Max.</th>";
	  }
   }
}
$output_table .= "</tr>\n";


#Get Day-Values
$stamp = strtotime($year."-".$month."-".$day);
if($month_selected == "complete") {
  while (date("Y", $stamp) == $year) {
    $time_from = $stamp * 1000;
    $time_to = ($stamp + 59 + 59*60 + 23*60*60) * 1000 + 999;
    $output_table .= "\n<tr>\n<td>".date("d.m.Y", $stamp)."</td>";
    for($i=0; $i < count($channel_id); $i++) {
      if($channel_selected[$channel_id[$i]] == 1) {
        $output_table .= "<td>&nbsp;</td>";
        $value=0;
        if($channel_type[$channel_id[$i]] == "power") {
          $str_sql = "SELECT SUM(value) FROM data WHERE channel_id=".$channel_id[$i]." AND timestamp BETWEEN $time_from AND $time_to";
          $sql_res = mysql_query($str_sql);
          $row = mysql_fetch_assoc($sql_res);
          $value = $row["SUM(value)"]/$channel_resolution[$channel_id[$i]];
        } else if ($channel_type[$channel_id[$i]] == "powersensor") {
          $day_value_Wh=0;
          $str_sql = "SELECT timestamp, value FROM data WHERE channel_id=".$channel_id[$i]." AND timestamp BETWEEN $time_from AND $time_to ORDER by timestamp desc";
          $sql_res = mysql_query($str_sql);
          $last_timestamp = 0;
          $last_value = 0;
          while($row = mysql_fetch_object($sql_res)) {
            if($last_timestamp > 0 && $last_value != 0){ $day_value_Wh+=($last_value*($last_timestamp-$row->timestamp)/1000/60/60); }
            $last_timestamp = $row->timestamp;
            $last_value = $row->value;
          }
          $value=$day_value_Wh/1000;
        }else if ($channel_type[$channel_id[$i]] == "electric meter") {
          $str_sql = "SELECT MIN(value) as start, MAX(value) as end FROM data WHERE channel_id=".$channel_id[$i]." AND value != 0 AND timestamp BETWEEN $time_from AND $time_to";
          $sql_res = mysql_query($str_sql);
          $row = mysql_fetch_assoc($sql_res);
          $value = ($row["end"]-$row["start"])/$channel_resolution[$channel_id[$i]];
        }else if($channel_type[$channel_id[$i]] == "gas") {
          $str_sql = "SELECT SUM(value) FROM data WHERE channel_id=".$channel_id[$i]." AND timestamp BETWEEN $time_from AND $time_to";
          $sql_res = mysql_query($str_sql);
          $row = mysql_fetch_assoc($sql_res);
          $value = $row["SUM(value)"]/$channel_resolution[$channel_id[$i]];
        }else if($channel_type[$channel_id[$i]] == "water") {
          $str_sql = "SELECT SUM(value) FROM data WHERE channel_id=".$channel_id[$i]." AND timestamp BETWEEN $time_from AND $time_to";
          $sql_res = mysql_query($str_sql);
          $row = mysql_fetch_assoc($sql_res);
          $value = $row["SUM(value)"]/$channel_resolution[$channel_id[$i]];
        }else if ($channel_type[$channel_id[$i]] == "temperature") {
          $str_sql = "SELECT MIN(value), AVG(value), MAX(value) FROM data WHERE channel_id=".$channel_id[$i]." AND value != 0 AND timestamp BETWEEN $time_from AND $time_to";
          $sql_res = mysql_query($str_sql);
          $row = mysql_fetch_assoc($sql_res);
          $value = $row["AVG(value)"];
		  $value_min = $row["MIN(value)"];
		  $value_max = $row["MAX(value)"];
		}else { 
          $output_table .= "<td>No valid Channel-Type: ".$channel_type[$channel_id[$i]]."</td>"; 
       }
	   if ($channel_type[$channel_id[$i]] != "temperature") {
          $output_table .= "<td>".round($value, 2).$channel_units[$channel_id[$i]]."</td>";
	   } else {
		  $output_table .= "<td>".round($value_min, 2).$channel_units[$channel_id[$i]]."</td><td>".round($value, 2).$channel_units[$channel_id[$i]]."</td><td>".round($value_max, 2).$channel_units[$channel_id[$i]]."</td>";
	   }
       $channel_data[$channel_id[$i]] .= "[gd(".date("Y", $stamp).", ".(date("n", $stamp)-1).", ".date("j", $stamp).") , $value],";
       if($value != 0) {
	      $channel_nod[$channel_id[$i]]++;
          $channel_total[$channel_id[$i]] += $value;
          if($value > $channel_max[$channel_id[$i]]) { $channel_max[$channel_id[$i]] = $value; }
          if($value < $channel_min[$channel_id[$i]]) { $channel_min[$channel_id[$i]] = $value; }
       } 
     } 
   }
   $output_table .= "</tr>\n";
   $stamp = strtotime("+1 day", $stamp);
  }
}else {
  while (date("m", $stamp) == $month) {
    $time_from = $stamp * 1000;
    $time_to = ($stamp + 59 + 59*60 + 23*60*60) * 1000 + 999;
    $output_table .= "\n<tr>\n<td>".date("d.m.Y", $stamp)."</td>";
    for($i=0; $i < count($channel_id); $i++) {
      if($channel_selected[$channel_id[$i]] == 1) {
        $output_table .= "<td>&nbsp;</td>";
        $value=0;
        if($channel_type[$channel_id[$i]] == "power") {
          $str_sql = "SELECT SUM(value) FROM data WHERE channel_id=".$channel_id[$i]." AND timestamp BETWEEN $time_from AND $time_to";
          $sql_res = mysql_query($str_sql);
          $row = mysql_fetch_assoc($sql_res);
          $value = $row["SUM(value)"]/$channel_resolution[$channel_id[$i]];
        }else if ($channel_type[$channel_id[$i]] == "powersensor") {
          $day_value_Wh=0;
          $str_sql = "SELECT timestamp, value FROM data WHERE channel_id=".$channel_id[$i]." AND timestamp BETWEEN $time_from AND $time_to ORDER by timestamp desc";
          $sql_res = mysql_query($str_sql);
          $last_timestamp = 0;
          $last_value = 0;
          while($row = mysql_fetch_object($sql_res)) {
            if($last_timestamp > 0 && $last_value != 0){ $day_value_Wh+=($last_value*($last_timestamp-$row->timestamp)/1000/60/60); } 
            $last_timestamp = $row->timestamp;
            $last_value = $row->value; 
          }
          $value=$day_value_Wh/1000;
        }else if ($channel_type[$channel_id[$i]] == "electric meter") {
          $str_sql = "SELECT MIN(value) as start, MAX(value) as end FROM data WHERE channel_id=".$channel_id[$i]." AND value != 0 AND timestamp BETWEEN $time_from AND $time_to";
          $sql_res = mysql_query($str_sql);
          $row = mysql_fetch_assoc($sql_res);
          $value = ($row["end"]-$row["start"])/$channel_resolution[$channel_id[$i]];
          }else if($channel_type[$channel_id[$i]] == "gas") {
          $str_sql = "SELECT SUM(value) FROM data WHERE channel_id=".$channel_id[$i]." AND timestamp BETWEEN $time_from AND $time_to";
          $sql_res = mysql_query($str_sql);
          $row = mysql_fetch_assoc($sql_res);
          $value = $row["SUM(value)"]/$channel_resolution[$channel_id[$i]];
		}else if($channel_type[$channel_id[$i]] == "water") {
          $str_sql = "SELECT SUM(value) FROM data WHERE channel_id=".$channel_id[$i]." AND timestamp BETWEEN $time_from AND $time_to";
          $sql_res = mysql_query($str_sql);
          $row = mysql_fetch_assoc($sql_res);
          $value = $row["SUM(value)"]/$channel_resolution[$channel_id[$i]];
		}else if($channel_type[$channel_id[$i]] == "temperature") {
           $str_sql = "SELECT MIN(value), AVG(value), MAX(value) FROM data WHERE channel_id=".$channel_id[$i]." AND timestamp BETWEEN $time_from AND $time_to";
           $sql_res = mysql_query($str_sql);
           $row = mysql_fetch_assoc($sql_res);
           $value = $row["AVG(value)"];
		   $value_min = $row["MIN(value)"];
		   $value_max = $row["MAX(value)"];
		}else {
           $output_table .= "<td>No valid Channel-Type: ".$channel_type[$channel_id[$i]]."</td>";
        }
		if ($channel_type[$channel_id[$i]] != "temperature") {
           $output_table .= "<td>".round($value, 2).$channel_units[$channel_id[$i]]."</td>";
	    } else {
		   $output_table .= "<td>".round($value_min, 2).$channel_units[$channel_id[$i]]."</td><td>".round($value, 2).$channel_units[$channel_id[$i]]."</td><td>".round($value_max, 2).$channel_units[$channel_id[$i]]."</td>";
	    }
        $channel_data[$channel_id[$i]] .= "[gd(".date("Y", $stamp).", ".(date("n", $stamp)-1).", ".date("j", $stamp).") , $value],";
        if($value != 0) {
	       $channel_nod[$channel_id[$i]]++;
           $channel_total[$channel_id[$i]] += $value;
           if($value > $channel_max[$channel_id[$i]]) { $channel_max[$channel_id[$i]] = $value; }
           if($value < $channel_min[$channel_id[$i]]) { $channel_min[$channel_id[$i]] = $value; }
        } 
      }
    }
    $output_table .= "</tr>\n";
    $stamp = strtotime("+1 day", $stamp);
  }
}

#Prepare Grpah and complete Form
$output_graph = "\n<script>\n";
$output_form .= "<br>\n";
$output_form .= "<table border=\"1\" width=\"95%\"><tr align=left><th width=24>&nbsp;<img  alt=\"select\" src=\"$image_path/eye.png\"/></th><th>Titel</th><th>Typ</th><th>Min</th><th>Max</th><th>&#216;</th><th>Gesamt</th></tr>\n";
for($i=0; $i < count($channel_id); $i++) {
  $output_graph .= "var data_".$channelArray[$i]." = [".$channel_data[$channelArray[$i]]."];\n"; 
  if($channel_nod[$channel_id[$i]] > 0) { $channel_average[$channel_id[$i]] = round($channel_total[$channel_id[$i]]/$channel_nod[$channel_id[$i]], 2); }
  $output_form .= "<tr><td bgcolor=\"".$channel_color[$channel_id[$i]]."\"><input type='checkbox' name='channel_".$channel_id[$i]."' value='channel_".$channel_id[$i]."'";
  if($channel_selected[$channel_id[$i]]) { $output_form .= " checked"; }
  $output_form .= "></td><td>&nbsp;&nbsp;<img  alt=\"".$channel_type[$channel_id[$i]]."\" src=\"$image_path/types/";
  if($channel_type[$channel_id[$i]] == "power") { $output_form .= "bolt.png"; }
  else if($channel_type[$channel_id[$i]] == "powersensor") { $output_form .= "bolt.png"; }
  else if($channel_type[$channel_id[$i]] == "electric meter") { $output_form .= "bolt.png"; }
  else if($channel_type[$channel_id[$i]] == "gas") { $output_form .= "flame.png"; }
  else if($channel_type[$channel_id[$i]] == "water") { $output_form .= "waterdrop.png"; }
  else if($channel_type[$channel_id[$i]] == "temperature") { $output_form .= "thermometer.png"; }
  $output_form .= "\"/>&nbsp;&nbsp;<b>".$channel_name[$channel_id[$i]]."</b></td>"; 
  if($channel_type[$channel_id[$i]] == "power") { $output_form .= "<td>&nbsp;&nbsp;El. Energie (S0-Impulse)</td>"; }
  else if($channel_type[$channel_id[$i]] == "powersensor") { $output_form .= "<td>&nbsp;&nbsp;El. Energie (Leistungswerte)</td>"; }
  else if($channel_type[$channel_id[$i]] == "electric meter") { $output_form .= "<td>&nbsp;&nbsp;El. Energie (Zahlerstaende)</td>"; }
  else if($channel_type[$channel_id[$i]] == "gas") { $output_form .= "<td>&nbsp;&nbsp;Gas (S0-Impulse)</td>"; }
  else if($channel_type[$channel_id[$i]] == "water") { $output_form .= "<td>&nbsp;&nbsp;Wasser (S0-Impulse)</td>"; }
  else if($channel_type[$channel_id[$i]] == "temperature") { $output_form .= "<td>&nbsp;&nbsp;Temperatur</td>"; }
 
  if ($channel_selected[$channel_id[$i]]){
    $output_form .= "<td>".round($channel_min[$channel_id[$i]], 2).$channel_units[$channel_id[$i]]."</td>";
    $output_form .= "<td>".round($channel_max[$channel_id[$i]], 2).$channel_units[$channel_id[$i]]."</td>";
    $output_form .= "<td>".round($channel_average[$channel_id[$i]], 2).$channel_units[$channel_id[$i]]."</td>";
	if ($channel_type[$channel_id[$i]] != "temperature") {
       $output_form .= "<td>".round($channel_total[$channel_id[$i]], 2).$channel_units[$channel_id[$i]]."</td></tr>\n";
    } else {
	   $output_form .= "<td>&nbsp;</td></tr>\n";	
	}
	
  } else {
    $output_form .= "<td>&nbsp;</td>";
    $output_form .= "<td>&nbsp;</td>";
    $output_form .= "<td>&nbsp;</td>";
    $output_form .= "<td>&nbsp;</td></tr>\n";
  }
} 
#End of Table and Form
$output_form .= "</table><br>\n";
$output_form .= "</fieldset>\n";
$output_form .= "</form>\n";
$output_table .= "</table><br>";

$output_graph .= "var dataset = [\n";
for($i=0; $i < count($channelArray); $i++) {
  $output_graph .= "{ label: \"".$channel_name[$channelArray[$i]]."\", data: data_".$channelArray[$i].", color:\"".$channel_color[$channelArray[$i]]."\", yaxis: 2 },";
}
$output_graph .= "];\n";
$output_graph .= "function gd(year, month, day) { \n";
$output_graph .= "  return new Date(year, month, day).getTime();\n";
$output_graph .= "}\n";
$output_graph .= "\n";
$output_graph .= "var options = {\n";
$output_graph .= "   xaxis: {\n";
$output_graph .= "      mode: \"time\",\n";
if($month_selected == "complete") { $output_graph .= "      tickSize: [1, \"month\"]\n"; }
else { 
  $output_graph .= "      tickSize: [1, \"day\"],\n"; 
  $output_graph .= "      timeformat: \"%d\"\n";
}
$output_graph .= "   }\n";
$output_graph .= "}\n";
$output_graph .= "\n";
$output_graph .= "$(document).ready(function () {\n";
$output_graph .= "  $.plot($(\"#flot-placeholder1\"), dataset, options);\n";
$output_graph .= "});\n";
$output_graph .= "\n";
$output_graph .= "</script>\n";
$output_graph .= "\n";
$output_graph .= "<body>\n";
$output_graph .= "  <div style=\"width:99%;height:50%;text-align:center;margin:10px\">\n";
$output_graph .= "    <div id=\"flot-placeholder1\" style=\"width:100%;height:100%;\"></div>\n";
$output_graph .= "  </div>\n";

echo $output_graph;
echo $output_form;
echo $output_table;

echo "</body>";

?>